#include <stdio.h>	
#include <Windows.h>
#include "Serial.h"

void SERIAL (int serial_port, int baud_rate, 
			 int samples, int sampling_interval, int bytes_perFrame) {
 char Data[]= {"@"};  // string {"@"} incorporates '@' and '\0'
 int Data_length=sizeof(Data)/sizeof(char);
 char receive_buf[4096];
 int loop,rxBytes,txBytes; 
 
 FILE *fp;
 fp = fopen("measurements.txt","a"); 
 fclose(fp);
 fp = fopen("measurements.txt","r+"); 
 fseek (fp, 0, SEEK_END); 
 
  if (SERIAL_Open(serial_port, baud_rate)) exit(0); // open port; exit if unavailable
  txBytes = SERIAL_Write(Data, Data_length-1); 
	// Data_length-1 to send only all but the terminating char (i.e.,'@' not '\0')
  Sleep(1000);
  
  for (loop=0; loop<samples; loop++) {
   SERIAL_WaitToReceive();
   rxBytes = SERIAL_Read(receive_buf, bytes_perFrame);
   if (rxBytes==0) { // if bytes not received, repeat the current loop iteration (--loop)
	   --loop;
	   continue;
   }
   printf(" loop%d: rxBytes=%d",loop,rxBytes);
   receive_buf[rxBytes]='\0'; // append zero to generate string buffer
   printf(" receive_buf=%s",receive_buf);
   fprintf(fp,"%s",receive_buf);   
   Sleep(sampling_interval);
  }

  SERIAL_Close(); 
 fclose(fp);  
}

int main()
{
	int P_samples = 100, ODR=12, frame_bytes=10;
	SERIAL (11, 115200, P_samples, ODR, frame_bytes); // frame is as: "1.010524",0x0d,0x0a
return(0);
}
